Drop openggsn and introduce osmo-ggsn

Take the opportunity to enable systemd service instead of sysvint like other osmocom
services already do.

Change-Id: Ie6018ef78ff18f2e6809fee957c9d645e35c7c9a
diff --git a/recipes-osmocom/osmo-ggsn/files/libgtp-queue_depth_32.patch b/recipes-osmocom/osmo-ggsn/files/libgtp-queue_depth_32.patch
new file mode 100644
index 0000000..52bc37b
--- /dev/null
+++ b/recipes-osmocom/osmo-ggsn/files/libgtp-queue_depth_32.patch
@@ -0,0 +1,13 @@
+diff --git a/gtp/queue.h b/gtp/queue.h
+index 556b6ef..d59a1a3 100644
+--- a/gtp/queue.h
++++ b/gtp/queue.h
+@@ -19,7 +19,7 @@
+ 
+ #define QUEUE_DEBUG 0		/* Print debug information */
+ 
+-#define QUEUE_SIZE 1024		/* Size of retransmission queue */
++#define QUEUE_SIZE 32		/* Size of retransmission queue */
+ #define QUEUE_HASH_SIZE 65536	/* Size of hash table (2^16) */
+ 
+ struct qmsg_t {			/* Holder for queued packets */
diff --git a/recipes-osmocom/osmo-ggsn/files/osmo-ggsn.init b/recipes-osmocom/osmo-ggsn/files/osmo-ggsn.init
new file mode 100755
index 0000000..157d6dd
--- /dev/null
+++ b/recipes-osmocom/osmo-ggsn/files/osmo-ggsn.init
@@ -0,0 +1,169 @@
+#!/bin/sh
+### BEGIN INIT INFO
+# Provides:          osmo-ggsn
+# Required-Start:    $network $local_fs
+# Required-Stop:
+# Default-Start:     2 3 4 5
+# Default-Stop:      0 1 6
+# Short-Description: Osmocom GSM network-in-a-box
+# Description:       A minimal implementation of the GSM Base Station Controller,
+#                    Mobile Switching Center, Home Location regster and all other
+#                    components to run a self-contained GSM network.
+### END INIT INFO
+
+# Author: Harald Welte <laforge@gnumonks.org>
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="Osmocom GGSN implementation"
+NAME=osmo-ggsn
+DAEMON=/usr/bin/ggsn
+DAEMON_ARGS=""             # Arguments to run the daemon with
+PIDFILE=/var/run/$NAME.pid
+SCRIPTNAME=/etc/init.d/$NAME
+CONFIG_FILE=/etc/ggsn.conf
+
+# Exit if the package is not installed
+[ -x $DAEMON ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
+
+# Load the VERBOSE setting and other rcS variables
+# . /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
+# . /lib/lsb/init-functions
+
+DAEMON_ARGS="$DAEMON_ARGS -c $CONFIG_FILE"
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+	# Return
+	#   0 if daemon has been started
+	#   1 if daemon was already running
+	#   2 if daemon could not be started
+        /sbin/modprobe tun
+	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
+		|| return 1
+
+	# Check for runtime directory of nonvolatile data
+	if [ ! -d /var/lib/ggsn ]; then
+		mkdir /var/lib/ggsn
+	fi
+
+	# Check for GTP restart counter
+	if [ ! -f /var/lib/ggsn/gsn_restart ]; then
+		echo 0 > /var/lib/ggsn/gsn_restart
+	fi
+
+	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
+		$DAEMON_ARGS \
+		|| return 2
+	# Add code here, if necessary, that waits for the process to be ready
+	# to handle requests from services started subsequently which depend
+	# on this one.  As a last resort, sleep for some time.
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+	# Return
+	#   0 if daemon has been stopped
+	#   1 if daemon was already stopped
+	#   2 if daemon could not be stopped
+	#   other if a failure occurred
+	start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
+	RETVAL="$?"
+	[ "$RETVAL" = 2 ] && return 2
+	# Wait for children to finish too if this is a daemon that forks
+	# and if the daemon is only ever run from this initscript.
+	# If the above conditions are not satisfied then add some other code
+	# that waits for the process to drop all resources that could be
+	# needed by services started subsequently.  A last resort is to
+	# sleep for some time.
+	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
+	[ "$?" = 2 ] && return 2
+	# Many daemons don't delete their pidfiles when they exit.
+	rm -f $PIDFILE
+	return "$RETVAL"
+}
+
+#
+# Function that sends a SIGHUP to the daemon/service
+#
+do_reload() {
+	#
+	# If the daemon can reload its configuration without
+	# restarting (for example, when it is sent a SIGHUP),
+	# then implement that here.
+	#
+	start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
+	return 0
+}
+
+case "$1" in
+  start)
+    #[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC " "$NAME"
+    do_start
+    #case "$?" in
+    #		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+    #		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+    #	esac
+  ;;
+  stop)
+	#[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+	do_stop
+	#case "$?" in
+	#	0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+	#	2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+	#esac
+	;;
+  status)
+       status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
+       ;;
+  #reload|force-reload)
+	#
+	# If do_reload() is not implemented then leave this commented out
+	# and leave 'force-reload' as an alias for 'restart'.
+	#
+	#log_daemon_msg "Reloading $DESC" "$NAME"
+	#do_reload
+	#log_end_msg $?
+	#;;
+  restart|force-reload)
+	#
+	# If the "reload" option is implemented then remove the
+	# 'force-reload' alias
+	#
+	#log_daemon_msg "Restarting $DESC" "$NAME"
+	do_stop
+	case "$?" in
+	  0|1)
+		do_start
+		#case "$?" in
+		#	0) log_end_msg 0 ;;
+		#	1) log_end_msg 1 ;; # Old process is still running
+		#	*) log_end_msg 1 ;; # Failed to start
+		#esac
+		;;
+	  *)
+	  	# Failed to stop
+		#log_end_msg 1
+		;;
+	esac
+	;;
+  *)
+	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
+	echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+	exit 3
+	;;
+esac
+
+:
diff --git a/recipes-osmocom/osmo-ggsn/osmo-ggsn_git.bb b/recipes-osmocom/osmo-ggsn/osmo-ggsn_git.bb
new file mode 100644
index 0000000..5a383b9
--- /dev/null
+++ b/recipes-osmocom/osmo-ggsn/osmo-ggsn_git.bb
@@ -0,0 +1,42 @@
+DESCRIPTION = "Osmocom GGSN implementation"
+HOMEPAGE = "https://osmocom.org/projects/openggsn"
+LICENSE = "GPLv2+"
+LIC_FILES_CHKSUM = "file://COPYING;md5=8ca43cbc842c2336e835926c2166c28b"
+PV = "1.0.0+gitr${SRCPV}"
+PR = "r0"
+
+SRCREV = "b5624c3d4838cd774c3a6df4208b709890174a25"
+SRC_URI = "git://git.osmocom.org/osmo-ggsn                   \
+           file://osmo-ggsn.init                             \
+	   file://libgtp-queue_depth_32.patch		    \
+          "
+S = "${WORKDIR}/git"
+
+DEPENDS = "libosmocore"
+
+PACKAGES =+ " libgtp libgtp-dev libgtp-staticdev osmo-sgsnemu"
+RDEPENDS_${PN} += "iptables kernel-module-ipt-masquerade kernel-module-tun"
+
+inherit autotools update-rc.d pkgconfig systemd
+
+do_install_append() {
+	install -d ${D}${sysconfdir}/init.d
+	install -d ${D}${systemd_system_unitdir}/
+	install -d ${D}/${sysconfdir}/osmocom/
+
+	install -m 0776 ${WORKDIR}/osmo-ggsn.init ${D}${sysconfdir}/init.d/osmo-ggsn
+	install -m 0644 ${S}/contrib/osmo-ggsn.service ${D}${systemd_system_unitdir}/
+	install -m 0644 ${S}/doc/examples/osmo-ggsn.cfg ${D}${sysconfdir}/osmocom/
+}
+
+SYSTEMD_SERVICE_osmo-ggsn = "osmo-ggsn.service"
+
+INITSCRIPT_PACKAGES = "osmo-ggsn"
+INITSCRIPT_NAME_osmo-ggsn = "osmo-ggsn"
+INITSCRIPT_PARAMS_osmo-ggsn = "defaults 29 29"
+
+FILES_libgtp = "${libdir}/*${SOLIBS}"
+FILES_libgtp-dev = "${includedir} ${libdir}/lib*${SOLIBSDEV} ${libdir}/*.la"
+FILES_libgtp-staticdev = "${libdir}/*.a"
+
+FILES_osmo-sgsnemu = "${bindir}/sgsnemu"